import { Pipe, PipeTransform } from '@angular/core';
/*
 * Raise the value exponentially
 * Takes an exponent argument that defaults to 1.
 * Usage:
 *   value | exponentialStrength:exponent
 * Example:
 *   {{ 2 | exponentialStrength:10 }}
 *   formats to: 1024
*/
@Pipe({name: 'translateStatus'})
export class LocalizationPipe implements PipeTransform {
  transform(value: string): string {
    switch (value) {
      case 'expected': return 'Forventet';
      case 'planned': return 'Planlagt';
      case 'finished': return 'Afholdt';
      default: return value;
    }
  }
}
