// import {ComponentFixture, fakeAsync, TestBed, tick} from '@angular/core/testing';
//
// import {EditMeasurementsModalComponent} from './edit-measurements-modal.component';
// import {of} from 'rxjs';
// import {FormsModule, NgForm} from '@angular/forms';
// import {AppModule} from '../../app.module';
// import {map} from 'rxjs/operators';
// import {By} from '@angular/platform-browser';
// import {DataCardService} from '../../api/data-card.service';
// import {ObservationService} from '../../api/observation.service';
//
// describe('EditMeasurementsModalComponent', () => {
//   let component: EditMeasurementsModalComponent;
//   let fixture: ComponentFixture<EditMeasurementsModalComponent>;
//
//   let dataCardServiceStub: DataCardService;
//   let observationService: ObservationService;
//
//   beforeEach(async () => {
//     dataCardServiceStub = {
//       activeDataCard$: of({
//         expectedDateOfDeliverySection: {},
//         prenatalRiskAssessmentSection: {
//           finalRiskAssessment: {
//             multiplicityRiskAssessment: {}
//           },
//         },
//         overallAssessmentSection: {prenatalCareAssessment: {numberOfFetuses: 2}}
//       }),
//       activities$: of([]),
//       update: () => of(),
//     } as any;
//
//     observationService = {
//       createUltrasoundObservations: () => of(),
//       createRegularObservations: () => of(),
//     } as any;
//
//     await TestBed.configureTestingModule({
//       declarations: [ EditMeasurementsModalComponent ],
//       imports: [FormsModule, AppModule],
//       providers: [
//         {provide: DataCardService, useValue: dataCardServiceStub},
//         {provide: ObservationService, useValue: observationService},
//         {provide: NgForm, useValue: new NgForm([], [])},
//       ]
//     })
//     .compileComponents();
//   });
//
//   beforeEach(() => {
//     fixture = TestBed.createComponent(EditMeasurementsModalComponent);
//     component = fixture.componentInstance;
//     fixture.detectChanges();
//   });
//
//   it('should create', () => {
//     expect(component).toBeTruthy();
//   });
//
//   it('fetches datacard and resets observationData on init', fakeAsync(() => {
//     component.isOpen = true;
//     component.ngOnChanges({isOpen: {}} as any);
//     fixture.detectChanges();
//     let accessed = false;
//     dataCardServiceStub.activeDataCard$ = of({overallAssessmentSection: {prenatalCareAssessment: {numberOfFetuses: 3}}} as any).pipe(
//       map(x => {accessed = true; return x; })
//     );
//     component.ngOnInit();
//     tick();
//     expect(accessed).toBeTrue();
//     expect(component.observationData?.fetuses?.length).toBe(3);
//   }));
//
//   it('allows save if activity was picked', fakeAsync(() => {
//     component.isOpen = true;
//     component.ngOnChanges({isOpen: {}} as any);
//     component.observationType = 'regular';
//     const spy = spyOn(observationService, 'createRegularObservations').and.callThrough();
//     component.observationData = {activityId: 'user_selected_some_id_in_form'} as any;
//     fixture.detectChanges();
//     component.doSave();
//     tick();
//     expect(spy).toHaveBeenCalled();
//   }));
//
//   it('does not allow save if no activity was picked', fakeAsync(() => {
//     component.isOpen = true;
//     component.ngOnChanges({isOpen: {}} as any);
//     component.observationType = 'regular';
//     const spy = spyOn(observationService, 'createRegularObservations').and.callThrough();
//     component.observationData = {} as any;
//     fixture.detectChanges();
//     component.doSave();
//     tick();
//     expect(spy).not.toHaveBeenCalled();
//     const activitySelector = fixture.debugElement.query(By.css('#activitySelector')).nativeElement;
//     expect(activitySelector.classList.contains('ng-invalid')).toBeTrue();
//   }));
//
//   it('just creates observation when in "regular" mode', fakeAsync(() => {
//     component.isOpen = true;
//     component.ngOnChanges({isOpen: {}} as any);
//     component.observationType = 'regular';
//     const dataCardSpy = spyOn(dataCardServiceStub, 'update').and.callThrough();
//     const regularObservationSpy = spyOn(observationService, 'createRegularObservations').and.callThrough();
//     component.observationData = {activityId: 'user_selected_some_id_in_form'} as any;
//     fixture.detectChanges();
//     component.doSave();
//     tick();
//     expect(dataCardSpy).not.toHaveBeenCalled();
//     expect(regularObservationSpy).toHaveBeenCalled();
//   }));
//
//   it('saves datacard and creates observations when in "ultrasound" mode', fakeAsync(() => {
//     component.isOpen = true;
//     component.ngOnChanges({isOpen: {}} as any);
//     component.observationType = 'ultrasound';
//     const dataCardSpy = spyOn(dataCardServiceStub, 'update').and.callThrough();
//     const scanObservationSpy = spyOn(observationService, 'createUltrasoundObservations').and.callThrough();
//     component.observationData = {activityId: 'user_selected_some_id_in_form'} as any;
//     fixture.detectChanges();
//     component.doSave();
//     tick();
//     expect(dataCardSpy).toHaveBeenCalled();
//     expect(scanObservationSpy).toHaveBeenCalled();
//   }));
//
//   it('handles that active datacard could be undefined', fakeAsync(() => {
//     component = new EditMeasurementsModalComponent({activeDataCard$: of()} as any, {} as any);
//     component.ngOnInit();
//     tick();
//     expect(component.dataCard).toBeUndefined();
//   }));
// });
