import {Component, Input} from '@angular/core';
import {MeasurementService} from '../../services/measurement.service';
import {Observable} from 'rxjs';
import {ClinicalObservationsServiceService} from './clinical-observations-service.service';
import {ObservationTable} from '@nspop/gm-web-facade-api';
import {ChartPoint} from './clinical-exams-line-chart/clinical-exams-line-chart.component';

@Component({
  selector: 'app-clinical-exams',
  templateUrl: './clinical-exams.component.html',
  styleUrls: ['./clinical-exams.component.scss', './tables.scss']
})
export class ClinicalExamsComponent {
  @Input() public editUltrasoundDialog: {isOpen: boolean; observationType: 'regular' | 'ultrasound' } | undefined;
  public testData: ChartPoint[] = [
    {week: 19, value: 15},
    {week: 22, value: 18},
    {week: 26, value: 24},
    {week: 37, value: 29}
    ];
  public tableObservable$: Observable<ObservationTable | undefined> = this.clinicalObservationsServiceService.observationGroups;
  constructor(private service: MeasurementService, private clinicalObservationsServiceService: ClinicalObservationsServiceService) { }

  public createMeasurements(): void {
    if (this.editUltrasoundDialog) {
      this.editUltrasoundDialog.observationType = 'regular';
      this.editUltrasoundDialog.isOpen = true;
    }
  }
}
