import {Component, Input, OnInit} from '@angular/core';
import {NumericValueWithUnit} from '@nspop/gm-web-facade-api';

@Component({
  selector: 'app-fetus-table',
  templateUrl: './fetus-table.component.html',
  styleUrls: ['./fetus-table.component.scss', './../tables.scss']
})
export class FetusTableComponent implements OnInit {
  @Input() fetus: {
    id: string,
    name: string,
    rows: {
      activityId: string,
      date: Date,
      gestationAge: string,
      ulWeight?: NumericValueWithUnit,
      weightDeviation?: NumericValueWithUnit,
      fetusPresentation?: string
    }[]} | undefined;

  constructor() { }

  ngOnInit(): void {
  }

}
