import {Component, forwardRef} from '@angular/core';
import {DataCardAllOfScreeningsSection} from '@nspop/gm-web-facade-api';
import deepEqual from 'deep-equal';
import {ControlContainer, ControlValueAccessor, NG_VALUE_ACCESSOR, NgForm} from '@angular/forms';

export const APP_MEASUREMENTS_SCREENINGS_CONTROL_VALUE_ACCESSOR: any = {
  provide: NG_VALUE_ACCESSOR,
  useExisting: forwardRef(() => MeasurementsScreeningsComponent),
  multi: true
};

@Component({
  selector: 'app-measurements-screenings',
  templateUrl: './measurements-screenings.component.html',
  styleUrls: ['./measurements-screenings.component.scss'],
  providers: [APP_MEASUREMENTS_SCREENINGS_CONTROL_VALUE_ACCESSOR],
  viewProviders: [ { provide: ControlContainer, useExisting: NgForm } ]
})
export class MeasurementsScreeningsComponent implements ControlValueAccessor {
  private innerModel: DataCardAllOfScreeningsSection | undefined;
  private dirtyAble = false;
  private onChangeCallback: (newValue: DataCardAllOfScreeningsSection | undefined) => any = () => {};
  private onTouchedCallback: () => any = () => {};
  constructor() {
  }

  registerOnChange(fn: any): void {
    this.onChangeCallback = fn;
  }

  registerOnTouched(fn: any): void {
    this.onTouchedCallback = fn;
  }

  writeValue(dataCardScreeningsSection: DataCardAllOfScreeningsSection): void {
    this.value = dataCardScreeningsSection;
  }
  get value(): DataCardAllOfScreeningsSection | undefined {
    return this.innerModel;
  }

  set value(value: DataCardAllOfScreeningsSection | undefined) {
    if (!deepEqual(value, this.innerModel)) {
      this.innerModel = value;
      if (this.dirtyAble) {
        this.onChangeCallback(value);
      }
      if (!this.dirtyAble && this.innerModel) { // We don't want to mark the field as dirty while data gets initialized
        this.dirtyAble = true;
      }
    }
  }
}
