import {DataCardWrapper} from './dataCard.wrapper';
import {DataCard} from '@nspop/gm-web-facade-api';

describe('DataCardWrapper', () => {
  it('reads and writes values for all properties', () => {
    const dataCard = {} as unknown as DataCard;
    const subject = new DataCardWrapper(dataCard);
    let length = 2;
    Object.getOwnPropertyNames(DataCardWrapper.prototype).forEach((property, index) => {
      if (typeof (subject as any)[property] === 'undefined') {
        (subject as any)[property] = `${index} value`;
        expect((subject as any)[property]).toBe(`${index} value`, `failed to read back the value set in '${property}'`);
        const stringified = JSON.stringify(dataCard);
        expect(stringified.length > length)
          .toBeTruthy(`Expected length of dataCard as json to be greater than ${length} after setting ${property} but it was ${stringified.length}`);
        length = stringified.length;
      }
    });
    // Randomly selected tests
    expect(dataCard.prenatalRiskAssessmentSection?.finalRiskAssessment?.multiplicityRiskAssessment?.comment).toContain(' value');
    expect(dataCard.alcoholDrinkingBehaviorSection?.weeklyConsumptionBeforePregnancy?.consumption?.value).toContain(' value');
  });
});
