import {
  AllergiesSection,
  DataCard,
  ExpectedDateOfDeliverySectionAllOfExpectedDateOfDeliveryFromLastPeriod,
  PosNegEnum,
  WeeklyConsumptionDuringPregnancy,
  WorkEnvironmentImpactSectionAllOfMother,
  YesNoEnum,
  WorkEnvironmentImpactSectionAllOfMotherExposureToWorkEnvironmentRisk,
  OverallAssessmentSectionAllOfPrenatalCareAssessment,
  PositiveNegativeDeclinedScreeningWithDateSection,
  ObstetricAssessment,
  SocialServicesPerinatalCareAssessment,
  MidwifeClinicSectionAllOfParentalCraftClassDesired,
  BodyMeasuresSection,
  ExpectedDateOfDeliverySection,
  OverallAssessmentSection,
  AssistedFertilizationSection,
  PreliminaryRiskAssessment,
  FinalRiskAssessment,
  WorkEnvironmentImpactSection,
  ChronicDiseasesSection,
  TobaccoUseAndExposureSection,
  AlcoholDrinkingBehaviorSection,
  DietaryAndExerciseSection,
  SubstanceUseSection,
  VersionedSection
} from '@nspop/gm-web-facade-api';
import {ObjectHelper} from './objectHelper';

/**
 * This class is a null-safe convenience wrapper around data-card. Use this to avoid null-pointers in bindings, since
 * angular does not support conditional chaning in ngModel bindings :sadpanda:
 *
 * Hold on to your butts, coz this is going to be a long one!
 */
export class DataCardWrapper {
  constructor(private dataCard: DataCard) {}
  get asDataCard(): DataCard {
    return this.dataCard;
  }

  get lastPeriod(): Date | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.lastPeriod;
  }
  set lastPeriod(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.lastPeriod', date);
  }
  get daysInMensCycleMin(): number | undefined {
    return (this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.menstrualCycle?.min)?.value;
  }
  set daysInMensCycleMin(days: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard,
    'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.menstrualCycle.min.value', days);
  }
  get daysInMensCycleMax(): number | undefined {
    return (this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.menstrualCycle?.max)?.value;
  }
  set daysInMensCycleMax(days: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard,
      'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.menstrualCycle.max.value', days);
  }
  get naegelsDateOfBirth(): Date | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.expectedDateOfDelivery;
  }
  set naegelsDateOfBirth(days: Date | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.expectedDateOfDelivery',
      days
    );
  }
  get expectedDateOfBirthCertainty(): ExpectedDateOfDeliverySectionAllOfExpectedDateOfDeliveryFromLastPeriod.CertaintyEnum | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromLastPeriod?.certainty;
  }
  set expectedDateOfBirthCertainty(careLevel:
                                     ExpectedDateOfDeliverySectionAllOfExpectedDateOfDeliveryFromLastPeriod.CertaintyEnum
                                     | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection.expectedDateOfDeliveryFromLastPeriod.certainty', careLevel);
  }
  get expectedDateOfBirthComment(): string | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.remarks;
  }
  set expectedDateOfBirthComment(remarks: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection.remarks', remarks);
  }
  get expectedDateOfBirthFromUltrasound(): Date | undefined {
    return this.dataCard?.expectedDateOfDeliverySection?.expectedDateOfDeliveryFromPrenatalUltrasoundScan;
  }
  set expectedDateOfBirthFromUltrasound(remarks: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection.expectedDateOfDeliveryFromPrenatalUltrasoundScan', remarks);
  }
  get fetusCount(): number | undefined {
    return this.dataCard?.overallAssessmentSection?.prenatalCareAssessment?.numberOfFetuses;
  }
  set fetusCount(count: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.prenatalCareAssessment.numberOfFetuses', count);
  }
  get bmiWeight(): number | undefined {
    return this.dataCard?.bodyMeasuresSection?.prenatalBodyWeight?.value;
  }
  set bmiWeight(weight: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'bodyMeasuresSection.prenatalBodyWeight.value', weight);
  }
  get bmiHeight(): number | undefined {
    return this.dataCard?.bodyMeasuresSection?.bodyHeight?.value;
  }
  set bmiHeight(height: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'bodyMeasuresSection.bodyHeight.value', height);
  }
  get bmi(): number | undefined {
    return this.dataCard?.bodyMeasuresSection?.bodyMassIndex?.value;
  }
  set bmi(bmi: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'bodyMeasuresSection.bodyMassIndex.value', bmi);
  }
  get fertilityTreatmentType(): AssistedFertilizationSection.TypeEnum | undefined {
    return this.dataCard?.assistedFertilizationSection?.type;
  }
  set fertilityTreatmentType(type: AssistedFertilizationSection.TypeEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'assistedFertilizationSection.type', type);
  }
  get fertilityTreatmentComment(): string | undefined {
    return this.dataCard?.assistedFertilizationSection?.remarks;
  }
  set fertilityTreatmentComment(remarks: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'assistedFertilizationSection.remarks', remarks);
  }
  get familyHistory(): string | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.familyHistory;
  }
  set familyHistory(history: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment.familyHistory', history);
  }
  get consanguinity(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.consanguinity;
  }
  set consanguinity(yes: boolean | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment.consanguinity', yes);
  }
  get firstTrimesterScanRequested(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.firstTrimesterUltrasoundScanOfFetusRequested;
  }
  set firstTrimesterScanRequested(requested: boolean | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment.firstTrimesterUltrasoundScanOfFetusRequested', requested);
  }
  get secondTrimesterScanRequested(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.secondTrimesterUltrasoundScanOfFetusRequested;
  }
  set secondTrimesterScanRequested(requested: boolean | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment.secondTrimesterUltrasoundScanOfFetusRequested', requested);
  }
  get riskAssessmentRequested(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment?.prenatalRiskAssessmentRequested;
  }
  set riskAssessmentRequested(requested: boolean | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.preliminaryRiskAssessment.prenatalRiskAssessmentRequested',
      requested
    );
  }
  get doubleTestCompleted(): boolean | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.doubleTestCompleted;
  }
  set doubleTestCompleted(completed: boolean | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.doubleTestCompleted', completed);
  }
  get doubleTestDate(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.doubleTestCompletedDate;
  }
  set doubleTestDate(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.doubleTestCompletedDate', date);
  }
  get mothersJobType(): string | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.jobType;
  }
  set mothersJobType(jobType: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.jobType', jobType);
  }
  get mothersJobHoursPrWeek(): number | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.hoursOfWorkPerWeek;
  }
  set mothersJobHoursPrWeek(hours: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.hoursOfWorkPerWeek', hours);
  }
  get mothersJobExposureTypes(): WorkEnvironmentImpactSectionAllOfMotherExposureToWorkEnvironmentRisk.TypesEnum[] | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.exposureToWorkEnvironmentRisk?.types;
  }
  set mothersJobExposureTypes(types: WorkEnvironmentImpactSectionAllOfMotherExposureToWorkEnvironmentRisk.TypesEnum[] | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.exposureToWorkEnvironmentRisk.types', types);
  }
  get mothersJobExposureRemarks(): string | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.exposureToWorkEnvironmentRisk?.remarks;
  }
  set mothersJobExposureRemarks(remarks: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.exposureToWorkEnvironmentRisk.remarks', remarks);
  }
  get mothersJobExposureStartDate(): Date | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.exposureToWorkEnvironmentRisk?.start;
  }
  set mothersJobExposureStartDate(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.exposureToWorkEnvironmentRisk.start', date);
  }
  get mothersJobExposureEndDate(): Date | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.exposureToWorkEnvironmentRisk?.end;
  }
  set mothersJobExposureEndDate(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.exposureToWorkEnvironmentRisk.end', date);
  }
  get mothersJobReferredToWorkMedicine(): boolean | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.referredToOccupationalHealthDepartmentForRiskAssessment;
  }
  set mothersJobReferredToWorkMedicine(referred: boolean | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'workEnvironmentImpactSection.mother.referredToOccupationalHealthDepartmentForRiskAssessment',
      referred
    );
  }
  get mothersJobPrenatalSickLeave(): WorkEnvironmentImpactSectionAllOfMother.PrenatalSickLeaveEnum | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.mother?.prenatalSickLeave;
  }
  set mothersJobPrenatalSickLeave(leave: WorkEnvironmentImpactSectionAllOfMother.PrenatalSickLeaveEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.mother.prenatalSickLeave', leave);
  }
  get partnersJobType(): string | undefined {
    return this.dataCard?.workEnvironmentImpactSection?.partner?.jobType;
  }
  set partnersJobType(type: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection.partner.jobType', type);
  }
  get mothersAllergies(): string | undefined {
    return this.dataCard?.allergiesSection?.allergiesOfMother;
  }
  set mothersAllergies(allergies: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'allergiesSection.allergiesOfMother', allergies);
  }
  get allergicPredispositionOfChild(): AllergiesSection.AllergicPredispositionOfChildEnum | undefined {
    return this.dataCard?.allergiesSection?.allergicPredispositionOfChild;
  }
  set allergicPredispositionOfChild(type: AllergiesSection.AllergicPredispositionOfChildEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'allergiesSection.allergicPredispositionOfChild', type);
  }
  get chronicDiseases(): ChronicDiseasesSection.ConditionsEnum[] | undefined {
    return this.dataCard?.chronicDiseasesSection?.conditions;
  }
  set chronicDiseases(type: ChronicDiseasesSection.ConditionsEnum[] | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'chronicDiseasesSection.conditions', type);
  }
  get chronicDiseasesComment(): string | undefined {
    return this.dataCard?.chronicDiseasesSection?.comment;
  }
  set chronicDiseasesComment(comment: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'chronicDiseasesSection.comment', comment);
  }
  get realMedicine(): string | undefined {
    return this.dataCard?.medicineSection?.realMedicine;
  }
  set realMedicine(medicine: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'medicineSection.realMedicine', medicine);
  }
  get natureMedicine(): string | undefined {
    return this.dataCard?.medicineSection?.natureMedicine;
  }
  set natureMedicine(medicine: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'medicineSection.natureMedicine', medicine);
  }
  get mfrVaccination(): string | undefined {
    return this.dataCard?.mmrVaccinationSection?.status;
  }
  set mfrVaccination(status: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'mmrVaccinationSection.status', status);
  }
  get previousAdmissions(): string | undefined {
    return this.dataCard?.historyOfPreviousTreatmentWithImpactOnPregnancySection?.history;
  }
  set previousAdmissions(admissions: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'historyOfPreviousTreatmentWithImpactOnPregnancySection.history', admissions);
  }
  get usedTobaccoBeforePregnancy(): TobaccoUseAndExposureSection.TobaccoUserEnum | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.tobaccoUser;
  }
  set usedTobaccoBeforePregnancy(usage: TobaccoUseAndExposureSection.TobaccoUserEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.tobaccoUser', usage);
  }
  get tobaccoEndDate(): Date | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.endDate;
  }
  set tobaccoEndDate(date: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.endDate', date);
  }
  get tobaccoDuringPregnancy(): YesNoEnum | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.smokeDuringPregnancy;
  }
  set tobaccoDuringPregnancy(usesTobacco: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.smokeDuringPregnancy', usesTobacco);
  }
  get referredToTobaccoStop(): YesNoEnum | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.referredToTobaccoCessationEducation;
  }
  set referredToTobaccoStop(referred: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.referredToTobaccoCessationEducation', referred);
  }
  get exposureToEnvironmentalSmoke(): YesNoEnum | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection?.exposureToEnvironmentalTobaccoSmoke;
  }
  set exposureToEnvironmentalSmoke(exposed: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection.exposureToEnvironmentalTobaccoSmoke', exposed);
  }
  get alcoholBeforePregnancy(): YesNoEnum | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionBeforePregnancy?.consumesAlcohol;
  }
  set alcoholBeforePregnancy(alcohol: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionBeforePregnancy.consumesAlcohol', alcohol);
  }
  get alcoholUnitsPrWeekBeforePregnancy(): number | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionBeforePregnancy?.consumption?.value;
  }
  set alcoholUnitsPrWeekBeforePregnancy(units: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionBeforePregnancy.consumption.value', units);
  }
  get alcoholDuringPregnancy(): YesNoEnum | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.consumesAlcohol;
  }
  set alcoholDuringPregnancy(alcohol: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.consumesAlcohol', alcohol);
  }
  get alcoholUnitsPrWeekDuringPregnancy(): number | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.consumption?.value;
  }
  set alcoholUnitsPrWeekDuringPregnancy(units: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.consumption.value', units);
  }
  get numberOfWeeksWithExcessiveDrinking(): number | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.excessiveDrinkingCount;
  }
  set numberOfWeeksWithExcessiveDrinking(value: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.excessiveDrinkingCount', value);
  }
  get excessiveDrinkingWeeks(): number[] | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.excessiveDrinkingWeeks;
  }
  set excessiveDrinkingWeeks(value: number[] | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.excessiveDrinkingWeeks', value);
  }
  get tweakPoints(): WeeklyConsumptionDuringPregnancy.TweakPointsEnum | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection?.weeklyConsumptionDuringPregnancy?.tweakPoints;
  }
  set tweakPoints(value: WeeklyConsumptionDuringPregnancy.TweakPointsEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection.weeklyConsumptionDuringPregnancy.tweakPoints', value);
  }
  get substanceUseBeforePregnancy(): YesNoEnum | undefined {
    return this.dataCard?.substanceUseSection?.substanceUseBeforePregnancy?.substanceUse;
  }
  set substanceUseBeforePregnancy(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection.substanceUseBeforePregnancy.substanceUse', value);
  }
  get substanceUseBeforePregnancyComment(): string | undefined {
    return this.dataCard?.substanceUseSection?.substanceUseBeforePregnancy?.text;
  }
  set substanceUseBeforePregnancyComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection.substanceUseBeforePregnancy.text', value);
  }
  get substanceUseDuringPregnancy(): YesNoEnum | undefined {
    return this.dataCard?.substanceUseSection?.substanceUseBeforePregnancy?.substanceUse;
  }
  set substanceUseDuringPregnancy(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection.substanceUseDuringPregnancy.substanceUse', value);
  }
  get substanceUseDuringPregnancyComment(): string | undefined {
    return this.dataCard?.substanceUseSection?.substanceUseBeforePregnancy?.text;
  }
  set substanceUseDuringPregnancyComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection.substanceUseDuringPregnancy.text', value);
  }
  get exerciseComment(): string | undefined {
    return this.dataCard?.dietaryAndExerciseSection?.text;
  }
  set exerciseComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'dietaryAndExerciseSection.text', value);
  }
  get hepatitisBResult(): PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined {
    return this.dataCard?.screeningsSection?.hepatitisB?.result;
  }
  set hepatitisBResult(value: PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hepatitisB.result', value);
  }
  get hepatitisBDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.hepatitisB?.date;
  }
  set hepatitisBDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hepatitisB.date', value);
  }
  get hivResult(): PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined {
    return this.dataCard?.screeningsSection?.hiv?.result;
  }
  set hivResult(value: PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hiv.result', value);
  }
  get hivDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.hiv?.date;
  }
  set hivDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hiv.date', value);
  }
  get syphilisResult(): PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined {
    return this.dataCard?.screeningsSection?.syphilis?.result;
  }
  set syphilisResult(value: PositiveNegativeDeclinedScreeningWithDateSection.ResultEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.syphilis.result', value);
  }
  get syphilisDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.syphilis?.date;
  }
  set syphilisDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.syphilis.date', value);
  }
  get chlamydiaResult(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.chlamydia?.result;
  }
  set chlamydiaResult(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.chlamydia.result', value);
  }
  get chlamydiaDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.chlamydia?.date;
  }
  set chlamydiaDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.chlamydia.date', value);
  }
  get gonorrheaResult(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.gonorrhea?.result;
  }
  set gonorrheaResult(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.gonorrhea.result', value);
  }
  get gonorrheaDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.gonorrhea?.date;
  }
  set gonorrheaDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.gonorrhea.date', value);
  }
  get hemoglobinopathyResult(): PosNegEnum | undefined {
    return this.dataCard?.screeningsSection?.hemoglobinopathy?.result;
  }
  set hemoglobinopathyResult(value: PosNegEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hemoglobinopathy.result', value);
  }
  get hemoglobinopathyDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.hemoglobinopathy?.date;
  }
  set hemoglobinopathyDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.hemoglobinopathy.date', value);
  }
  get mrsaSwapDone(): YesNoEnum | undefined {
    return this.dataCard?.screeningsSection?.mrsaSwap?.value;
  }
  set mrsaSwapDone(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.mrsaSwap.value', value);
  }
  get mrsaSwapDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.mrsaSwap?.date;
  }
  set mrsaSwapDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.mrsaSwap.date', value);
  }
  get vitaminDConsumption(): number | undefined {
    return this.dataCard?.screeningsSection?.vitaminDConsumption?.value;
  }
  set vitaminDConsumption(value: number | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.vitaminDConsumption.value', value);
  }
  get vitaminDConsumptionDate(): Date | undefined {
    return this.dataCard?.screeningsSection?.vitaminDConsumption?.date;
  }
  set vitaminDConsumptionDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'screeningsSection.vitaminDConsumption.date', value);
  }
  get prenatalCareAssessment(): string | undefined {
    return this.dataCard?.overallAssessmentSection?.prenatalCareAssessment?.assessment;
  }
  set prenatalCareAssessment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.prenatalCareAssessment.assessment', value);
  }
  get generalPractitionerName(): string | undefined {
    return this.dataCard?.personalDataSection?.generalPractitioner?.name;
  }
  set generalPractitionerName(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'personalDataSection.generalPractitioner.name', value);
  }
  get careLevel(): OverallAssessmentSectionAllOfPrenatalCareAssessment.CareLevelEnum | undefined {
    return this.dataCard?.overallAssessmentSection?.prenatalCareAssessment?.careLevel;
  }
  set careLevel(value: OverallAssessmentSectionAllOfPrenatalCareAssessment.CareLevelEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.prenatalCareAssessment.careLevel', value);
  }
  get prenatalCareAssessmentComment(): string | undefined {
    return this.dataCard?.overallAssessmentSection?.prenatalCareAssessment?.comment;
  }
  set prenatalCareAssessmentComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.prenatalCareAssessment.comment', value);
  }
  get obstetricAssessmentRequired(): YesNoEnum | undefined {
    return this.dataCard?.overallAssessmentSection?.obstetricAssessment?.required;
  }
  set obstetricAssessmentRequired(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.obstetricAssessment.required', value);
  }
  get obstetricAssessmentReason(): string | undefined {
    return (this.dataCard?.overallAssessmentSection?.obstetricAssessment as ObstetricAssessment)?.reason;
  }
  set obstetricAssessmentReason(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.obstetricAssessment.reason', value);
  }
  get socialServicesRequired(): YesNoEnum | undefined {
    return this.dataCard?.overallAssessmentSection?.socialServicesPerinatalCareAssessment?.required;
  }
  set socialServicesRequired(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.socialServicesPerinatalCareAssessment.required', value);
  }
  get socialServicesReason(): string | undefined {
    return (this.dataCard?.overallAssessmentSection?.socialServicesPerinatalCareAssessment as SocialServicesPerinatalCareAssessment)
      ?.reason;
  }
  set socialServicesReason(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection.socialServicesPerinatalCareAssessment.reason', value);
  }
  get desiredBirthPlace(): string | undefined {
    return this.dataCard?.birthPlaceSection?.desiredBirthPlace;
  }
  set desiredBirthPlace(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'birthPlaceSection.desiredBirthPlace', value);
  }
  get desiredBirthPlaceLocation(): string | undefined {
    return this.dataCard?.midwifeClinicSection?.midwifeConsultationWishes?.location;
  }
  set desiredBirthPlaceLocation(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.midwifeConsultationWishes.location', value);
  }
  get desiredBirthPlaceNotes(): string | undefined {
    return this.dataCard?.midwifeClinicSection?.midwifeConsultationWishes?.notes;
  }
  set desiredBirthPlaceNotes(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.midwifeConsultationWishes.notes', value);
  }
  get primaryPlannedBirthPlace(): string | undefined {
    return this.dataCard?.birthPlaceSection?.primaryPlannedBirthPlace?.name;
  }
  set primaryPlannedBirthPlace(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'birthPlaceSection.primaryPlannedBirthPlace.name', value);
  }
  get revisedPlannedBirthPlace(): string | undefined {
    return this.dataCard?.birthPlaceSection?.revisedPlannedBirthPlace?.name;
  }
  set revisedPlannedBirthPlace(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'birthPlaceSection.revisedPlannedBirthPlace.name', value);
  }
  get assignedMidwifeClinic(): string | undefined {
    return this.dataCard?.midwifeClinicSection?.assignedMidwifeClinic?.name;
  }
  set assignedMidwifeClinic(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.assignedMidwifeClinic.name', value);
  }
  get parentalCraftClassDesired(): YesNoEnum | undefined {
    return this.dataCard?.midwifeClinicSection?.parentalCraftClassDesired?.parentalCraftClassDesired;
  }
  set parentalCraftClassDesired(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.parentalCraftClassDesired.parentalCraftClassDesired', value);
  }
  get midwifeConsultationForm(): MidwifeClinicSectionAllOfParentalCraftClassDesired.ConsultationFormEnum | undefined {
    return this.dataCard?.midwifeClinicSection?.parentalCraftClassDesired?.consultationForm;
  }
  set midwifeConsultationForm(value: MidwifeClinicSectionAllOfParentalCraftClassDesired.ConsultationFormEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'midwifeClinicSection.parentalCraftClassDesired.consultationForm', value);
  }
  get firstTrimesterScan(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.firstTrimesterUltrasoundScanOfFetusCompleted;
  }
  set firstTrimesterScan(value: Date | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.finalRiskAssessment.firstTrimesterUltrasoundScanOfFetusCompleted',
      value
    );
  }
  get secondTrimesterScan(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.secondTrimesterUltrasoundScanOfFetusCompleted;
  }
  set secondTrimesterScan(value: Date | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.finalRiskAssessment.secondTrimesterUltrasoundScanOfFetusCompleted',
      value
    );
  }
  get downsProbability(): 'high' | 'low' | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.downsScreeningProbabilityAssessment;
  }
  set downsProbability(value: 'high' | 'low' | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.downsScreeningProbabilityAssessment', value);
  }
  get multiplicityRisk(): YesNoEnum | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.multiplicityRiskAssessment?.risk;
  }
  set multiplicityRisk(value: YesNoEnum | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.multiplicityRiskAssessment.risk', value);
  }
  get multiplicityRiskComment(): string | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.multiplicityRiskAssessment?.comment;
  }
  set multiplicityRiskComment(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.multiplicityRiskAssessment.comment', value);
  }
  get placentalBiopsyDate(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.placentalBiopsiObservation?.date;
  }
  set placentalBiopsyDate(value: Date | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.placentalBiopsiObservation.date', value);
  }
  get placentalBiopsyResult(): string | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.placentalBiopsiObservation?.result;
  }
  set placentalBiopsyResult(value: string | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment.placentalBiopsiObservation.result', value);
  }
  get prenatalAmniocentesisDate(): Date | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.prenatalAmniocentesisiObservation?.date;
  }
  set prenatalAmniocentesisDate(value: Date | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.finalRiskAssessment.prenatalAmniocentesisiObservation.date',
      value
    );
  }
  get prenatalAmniocentesisResult(): string | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment?.prenatalAmniocentesisiObservation?.result;
  }
  set prenatalAmniocentesisResult(value: string | undefined) {
    ObjectHelper.setOnPath(
      this.dataCard,
      'prenatalRiskAssessmentSection.finalRiskAssessment.prenatalAmniocentesisiObservation.result',
      value
    );
  }
  get bodyMeasuresSection(): BodyMeasuresSection | undefined {
    return this.dataCard?.bodyMeasuresSection;
  }
  set bodyMeasuresSection(value: BodyMeasuresSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'bodyMeasuresSection', value);
  }
  get expectedDateOfDeliverySection(): ExpectedDateOfDeliverySection | undefined {
    return this.dataCard?.expectedDateOfDeliverySection;
  }
  set expectedDateOfDeliverySection(value: ExpectedDateOfDeliverySection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'expectedDateOfDeliverySection', value);
  }
  get overallAssessmentSection(): OverallAssessmentSection | undefined {
    return this.dataCard?.overallAssessmentSection;
  }
  set overallAssessmentSection(value: OverallAssessmentSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'overallAssessmentSection', value);
  }
  get assistedFertilizationSection(): AssistedFertilizationSection | undefined {
    return this.dataCard?.assistedFertilizationSection;
  }
  set assistedFertilizationSection(value: AssistedFertilizationSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'assistedFertilizationSection', value);
  }
  get preliminaryRiskAssessment(): PreliminaryRiskAssessment | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.preliminaryRiskAssessment;
  }
  set preliminaryRiskAssessment(value: PreliminaryRiskAssessment | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.preliminaryRiskAssessment', value);
  }
  get finalRiskAssessment(): FinalRiskAssessment | undefined {
    return this.dataCard?.prenatalRiskAssessmentSection?.finalRiskAssessment;
  }
  set finalRiskAssessment(value: FinalRiskAssessment | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'prenatalRiskAssessmentSection.finalRiskAssessment', value);
  }
  get workEnvironmentImpactSection(): WorkEnvironmentImpactSection | undefined {
    return this.dataCard?.workEnvironmentImpactSection;
  }
  set workEnvironmentImpactSection(value: WorkEnvironmentImpactSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'workEnvironmentImpactSection', value);
  }
  get allergiesSection(): AllergiesSection | undefined {
    return this.dataCard?.allergiesSection;
  }
  set allergiesSection(value: AllergiesSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'allergiesSection', value);
  }
  get chronicDiseasesSection(): ChronicDiseasesSection | undefined {
    return this.dataCard?.chronicDiseasesSection;
  }
  set chronicDiseasesSection(value: ChronicDiseasesSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'chronicDiseasesSection', value);
  }
  get medicineSection(): VersionedSection | undefined {
    return this.dataCard?.medicineSection;
  }
  set medicineSection(value: VersionedSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'medicineSection', value);
  }
  get mmrVaccinationSection(): VersionedSection | undefined {
    return this.dataCard?.mmrVaccinationSection;
  }
  set mmrVaccinationSection(value: VersionedSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'mmrVaccinationSection', value);
  }
  get tobaccoUseAndExposureSection(): TobaccoUseAndExposureSection | undefined {
    return this.dataCard?.tobaccoUseAndExposureSection;
  }
  set tobaccoUseAndExposureSection(value: TobaccoUseAndExposureSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'tobaccoUseAndExposureSection', value);
  }
  get alcoholDrinkingBehaviorSection(): AlcoholDrinkingBehaviorSection | undefined {
    return this.dataCard?.alcoholDrinkingBehaviorSection;
  }
  set alcoholDrinkingBehaviorSection(value: AlcoholDrinkingBehaviorSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'alcoholDrinkingBehaviorSection', value);
  }
  get substanceUseSection(): SubstanceUseSection | undefined {
    return this.dataCard?.substanceUseSection;
  }
  set substanceUseSection(value: SubstanceUseSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'substanceUseSection', value);
  }
  get dietaryAndExerciseSection(): DietaryAndExerciseSection | undefined {
    return this.dataCard?.dietaryAndExerciseSection;
  }
  set dietaryAndExerciseSection(value: DietaryAndExerciseSection | undefined) {
    ObjectHelper.setOnPath(this.dataCard, 'dietaryAndExerciseSection', value);
  }
}
