export class ObjectHelper {
  public static setOnPath<T>(obj: T, path: string, value: any): T {
    const result = obj ?? {} as T;
    if (!path) {
      return value;
    }
    const properties = path.split('.');
    let current: any = result;
    for (const property of properties.slice(0, properties.length - 1)) {
      if (current[property] == null) {
        if (!value) {
          // the property does not exist and we don't want it to have a value... We're done here
          return result;
        }
        current[property] = {};
      }
      current = current[property];
    }
    current[properties[properties.length - 1]] = value;
    return result;
  }

}
