import { CprPipe } from './cpr.pipe';

describe('CprPipe', () => {
  it('handles null', () => {
    const pipe = new CprPipe();
    expect(pipe.transform(null)).toEqual('?');
  });

  it('handles undefined', () => {
    const pipe = new CprPipe();
    expect(pipe.transform(undefined)).toEqual('?');
  });

  it('does not format incomplete CPR numbers', () => {
    const pipe = new CprPipe();
    expect(pipe.transform('12345')).toEqual('12345');
  });

  it('formats a normal CPR', () => {
    const pipe = new CprPipe();
    expect(pipe.transform('2705001234')).toEqual('270500-1234');
  });

  it('formats a replacement CPR', () => {
    const pipe = new CprPipe();
    expect(pipe.transform('2705001HS4')).toEqual('270500-1HS4');
  });

  it('formats a longer CPR', () => {
    const pipe = new CprPipe();
    expect(pipe.transform('200005271234')).toEqual('200005-271234');
  });
});
