import {Injectable} from '@angular/core';
import {Observable} from 'rxjs';
import {HttpClient} from '@angular/common/http';
import {environment} from '../../environments/environment';
import {FeedbackEntity} from '@nspop/gm-web-facade-api';

@Injectable({
  providedIn: 'root'
})
export class FeedbackService {
  constructor(private httpClient: HttpClient) {}

  sendFeedback(feedback: FeedbackEntity): Observable<FeedbackEntity> {
    console.log(`Feedback service sendFeedback(): \nRating: ${feedback.rating}\nComment: ${feedback.comment || '<none>'}`);
    return this.httpClient.post<FeedbackEntity>(`${environment.base_path }/api/feedback/v1`, feedback);
  }
}
