import {ComponentFixture, TestBed} from '@angular/core/testing';

import { TriageOverviewComponent } from './triage-overview.component';
import {of} from 'rxjs';
import {FormsModule, NgForm} from '@angular/forms';
import {AppModule} from '../app.module';
import {AngularMaterialModule} from '../modules/angular-material.module';
import {MatIconTestingModule} from '@angular/material/icon/testing';
import {DataCardService} from '../api/data-card.service';

describe('TriageOverviewComponent', () => {
  let component: TriageOverviewComponent;
  let fixture: ComponentFixture<TriageOverviewComponent>;

  let dataCardServiceStub: DataCardService;

  beforeEach(async () => {
    dataCardServiceStub = {
      activeDataCard$: of({documentUniqueId: '1', version: '2', episodeOfCareIdentifier: '3', dummy: true})
    } as any;

    await TestBed.configureTestingModule({
      declarations: [ TriageOverviewComponent ],
      imports: [FormsModule, AppModule, AngularMaterialModule, MatIconTestingModule],
      providers: [
        {provide: DataCardService, useValue: dataCardServiceStub},
        {provide: NgForm, useValue: new NgForm([], [])},
      ]
    })
    .compileComponents();
  });

  beforeEach(() => {
    fixture = TestBed.createComponent(TriageOverviewComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });
});
