import {Component, OnInit} from '@angular/core';
import {DataCard} from '@nspop/gm-web-facade-api';
import {DataCardService} from '../api/data-card.service';

@Component({
  selector: 'app-triage-overview',
  templateUrl: './triage-overview.component.html',
  styleUrls: ['./triage-overview.component.scss']
})
export class TriageOverviewComponent implements OnInit {
  public dataCard: DataCard | undefined;

  constructor(private dataCardService: DataCardService) { }

  ngOnInit(): void {
    this.dataCardService.activeDataCard$
      .subscribe((dataCard: DataCard | undefined) => {
        if (dataCard) {
          this.dataCard = dataCard;
        }
      });
  }
}
