import {LocalStorageUserContext, UserAuthorizationType} from '../app/services/user-context.service';
import {SorItem} from '../app/services/sor.service';

function setLocalStorageUserContext(user: string, context: LocalStorageUserContext): void {
  localStorage.setItem(user, JSON.stringify(context));
}

export function setLocalStorageRole(user: string, role: UserAuthorizationType): void {
  const localStorageUserContext = getLocalStorageUserContext(user);
  if (localStorageUserContext){
    localStorageUserContext.role = role;
    setLocalStorageUserContext(user, localStorageUserContext);
  } else {
    setLocalStorageUserContext(user, {role});
  }
}

export function setLocalStorageOrganisationSor(user: string, organizationSor: SorItem): void {
  const localStorageUserContext = getLocalStorageUserContext(user);
  if (localStorageUserContext){
    localStorageUserContext.organizationSor = organizationSor;
    setLocalStorageUserContext(user, localStorageUserContext);
  } else {
    setLocalStorageUserContext(user, {organizationSor});
  }
}

export function getLocalStorageUserContext(user: string): LocalStorageUserContext | undefined {
  const context = localStorage.getItem(user);
  if (context){
    return JSON.parse(context);
  }
  return undefined;
}

