import {Observable, OperatorFunction, pipe, UnaryFunction} from 'rxjs';
import {filter} from 'rxjs/operators';

/**
 * Can filter out nullish observables
 * Used to type cast Observables
 * https://stackoverflow.com/questions/57999777/filter-undefined-from-rxjs-observable
 */
export function filterNullish<T>(): UnaryFunction<Observable<T | null | undefined>, Observable<T>> {
  return pipe(
    filter(x => x != null) as OperatorFunction<T | null |  undefined, T>
  );
}
